# SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause
%YAML 1.2
---
$id: http://devicetree.org/schemas/net/brcm,amac.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Broadcom AMAC Ethernet Controller Device Tree Bindings

maintainers:
  - Florian Fainelli <f.fainelli@gmail.com>

allOf:
  - $ref: "ethernet-controller.yaml#"
  - if:
      properties:
        compatible:
          contains:
            enum:
              - brcm,amac
    then:
      properties:
        reg:
          maxItems: 2
        reg-names:
          maxItems: 2

  - if:
      properties:
        compatible:
          contains:
            enum:
              - brcm,nsp-amac
    then:
      properties:
        reg:
          minItems: 2
          maxItems: 2
        reg-names:
          minItems: 2
          maxItems: 2

  - if:
      properties:
        compatible:
          contains:
            enum:
              - brcm,ns2-amac
    then:
      properties:
        reg:
          minItems: 3
        reg-names:
          minItems: 3

properties:
  compatible:
    enum:
      - brcm,amac
      - brcm,nsp-amac
      - brcm,ns2-amac

  interrupts:
    maxItems: 1

  reg:
    minItems: 1
    maxItems: 3

  reg-names:
    minItems: 1
    items:
      - const: amac_base
      - const: idm_base
      - const: nicpm_base

unevaluatedProperties: false

examples:
  - |
   #include <dt-bindings/interrupt-controller/arm-gic.h>

   amac0: ethernet@18022000 {
      compatible = "brcm,nsp-amac";
      reg = <0x18022000 0x1000>,
            <0x18110000 0x1000>;
      reg-names = "amac_base", "idm_base";
      interrupts = <GIC_SPI 147 IRQ_TYPE_LEVEL_HIGH>;
   };
